﻿package
{
	import com.cb.utils.simplepaint.SimplePaint;
	
	import flash.desktop.NativeApplication;
	import flash.desktop.SystemIdleMode;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.BrowserInvokeEvent;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.events.TouchEvent;
	import flash.geom.Point;
	import flash.system.Capabilities;
	import flash.ui.Keyboard;
	import flash.ui.MouseCursor;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(frameRate="30", width="400", height="400")]
	public class FlashPaint extends MovieClip
	{
		private var _canvas:SimplePaint;
		private var _undoButton:Sprite;
		private var _clearButton:Sprite;
		private var _exitButton:Sprite;
		private var _drawing:Boolean;
		private var _menuBar:MenuBar;
		private var _webMode:Boolean = true;
		
		public function FlashPaint()
		{
			super();
			if(stage){
				init();
			}else{
				this.addEventListener("addedToStage", init);
			}
		}
		
		private function init(e:Event = null):void
		{
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;

			if(Capabilities.cpuArchitecture=="ARM")
			{
				NativeApplication.nativeApplication.addEventListener(Event.ACTIVATE, handleActivate, false, 0, true);
				NativeApplication.nativeApplication.addEventListener(Event.DEACTIVATE, handleDeactivate, false, 0, true);
				NativeApplication.nativeApplication.addEventListener(KeyboardEvent.KEY_DOWN, handleKeys, false, 0, true);
			}
			
			_menuBar = new MenuBar();
			if(_webMode){
				_canvas = new SimplePaint(400, 400-85);
			}else if(Capabilities.screenResolutionX < 400){
				_canvas = new SimplePaint(Capabilities.screenResolutionX, Capabilities.screenResolutionY-85);
				_canvas.ratio = 0.66;
			}else{
				_canvas = new SimplePaint(Capabilities.screenResolutionX, Capabilities.screenResolutionY-125);
				_menuBar.scaleX = _menuBar.scaleY = 1.5;
			}
			
			this.addChild(_canvas);
			
			if(Multitouch.maxTouchPoints > 0){
				Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
				_canvas.addEventListener(TouchEvent.TOUCH_BEGIN, onTouchBegin);
				_canvas.addEventListener(TouchEvent.TOUCH_MOVE, onTouchMove);
				_canvas.addEventListener(TouchEvent.TOUCH_END, onTouchEnd);
			}else{
				_canvas.addEventListener(MouseEvent.MOUSE_DOWN, onMouseBegin);
				_canvas.addEventListener(MouseEvent.MOUSE_MOVE, onMyMouseMove);
				_canvas.addEventListener(MouseEvent.MOUSE_UP, onMouseEnd);
			}
			
			_menuBar.y = _canvas.height;
			_menuBar.x = (_canvas.width - _menuBar.width)/2;
			
			_menuBar.undoButton.addEventListener(MouseEvent.CLICK, onUndo);
			_menuBar.smallBrushButton.addEventListener(MouseEvent.CLICK,onSmallSelect);
			_menuBar.bigBrushButton.addEventListener(MouseEvent.CLICK,onBigSelect);
			_menuBar.clearButton.addEventListener(MouseEvent.CLICK,onClear);
			_menuBar.penButton.addEventListener(MouseEvent.CLICK,onPen);
			_menuBar.eraserButton.addEventListener(MouseEvent.CLICK,onEraser);
			
			this.addChild(_menuBar);
		}
		
		private function onPen(e:MouseEvent):void
		{
			_menuBar.selectionBox.x = _menuBar.penButton.x;
			_canvas.brushStyle = SimplePaint.PEN_BRUSH;
		}
		
		private function onEraser(e:MouseEvent):void
		{
			_menuBar.selectionBox.x = _menuBar.eraserButton.x;
			_canvas.brushStyle = SimplePaint.ERASER_BRUSH;
		}
		
		private function onUndo(e:MouseEvent):void
		{
			_canvas.undo();
		}
		
		private function onSmallSelect(e:MouseEvent):void
		{
			_menuBar.selectionBox.x = _menuBar.smallBrushButton.x;
			_canvas.brushStyle = SimplePaint.SMALL_BRUSH;
		}
		
		private function onBigSelect(e:MouseEvent):void
		{
			_menuBar.selectionBox.x = _menuBar.bigBrushButton.x;
			_canvas.brushStyle = SimplePaint.LARGE_BRUSH;
		}
		
		private function onClear(e:MouseEvent):void
		{
			_canvas.clear();
		}
		
		private function onTouchBegin(e:TouchEvent):void
		{
			_canvas.brushDown(String(e.touchPointID), new Point(e.stageX, e.stageY));
		}
		
		private function onMouseBegin(e:MouseEvent):void
		{
			_drawing = true;
			_canvas.brushDown("1024", new Point(this.mouseX, this.mouseY));
		}
		
		private function onTouchMove(e:TouchEvent):void
		{
			_canvas.brushMove(String(e.touchPointID), new Point(e.stageX, e.stageY));
		}
		
		private function onMyMouseMove(e:MouseEvent):void
		{
			if(_drawing){
				_canvas.brushMove("1024", new Point(this.mouseX, this.mouseY));
			}
		}
		
		private function onTouchEnd(e:TouchEvent):void
		{
			_canvas.brushUp(String(e.touchPointID));
		}	
		
		private function onMouseEnd(e:MouseEvent):void
		{
			if(_drawing){
				_drawing = false;
				_canvas.brushUp("1024");
			}
		}	
		
		private function handleActivate(event:Event):void
		{
			NativeApplication.nativeApplication.systemIdleMode = SystemIdleMode.KEEP_AWAKE;
		}
		
		private function handleDeactivate(event:Event):void
		{
			NativeApplication.nativeApplication.exit();
		}
		
		private function handleKeys(event:KeyboardEvent):void
		{
			if(event.keyCode == 16777238)
				NativeApplication.nativeApplication.exit();
		}
	}
}