package com.cb.utils.simplepaint.brush 
{
	import com.cb.utils.simplepaint.SimplePaint;
	import com.cb.utils.simplepaint.brush.strokes.BrushStroke;
	import com.cb.utils.simplepaint.brush.strokes.PaintEraserStroke;
	import com.cb.utils.simplepaint.brush.strokes.PaintPenStroke;
	import com.cb.utils.simplepaint.brush.strokes.PaintPngStroke;
	import com.cb.utils.simplepaint.brush.strokes.PaintSquareStroke;
	import com.cb.utils.simplepaint.brush.strokes.PaintStroke;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.utils.Dictionary;
	import flash.utils.Timer;

	public class PaintBrush extends Sprite
	{
		public var color:uint = 0x000000;
		public var transparency:Number;
		private var _strokes:Dictionary;
		private var _width:int;
		private var _height:int;
		
		public function PaintBrush(width:int = 400, height:int = 400)
		{
			super();
			_strokes = new Dictionary();	
			_width = width;
			_height = height;
		}
		
		public function beginPaint(id:String, pt:Point, bs:String, ratio:Number):void
		{
			switch (bs){
				case SimplePaint.SMALL_BRUSH:
					_strokes[id] = new PaintPngStroke(Math.round( Math.random()*0xFFFFFF ), 16, pt, id, _width, _height, ratio);
				break;
				case SimplePaint.LARGE_BRUSH:
					_strokes[id] = new PaintSquareStroke(Math.round( Math.random()*0xFFFFFF ), 40, pt, id, _width, _height, ratio);
				break;
				case SimplePaint.PEN_BRUSH:
					_strokes[id] = new PaintPenStroke(0x000000, 3, pt, id, _width, _height, ratio);
				break;
				case SimplePaint.ERASER_BRUSH:
					_strokes[id] = new PaintEraserStroke(0xFFFFFF, 50, pt, id, _width, _height, ratio);
				break;
			}
			
			this.addChild(_strokes[id]);
		}
		
		public function brushMove(id:String, pt:Point):void
		{
			if(pt.y > 0 && pt.x > 0 && _strokes[id]){
				(_strokes[id] as PaintStroke).paint(pt);
			}
		}
		
		public function setDimensions(width:int, height:int):void
		{
			_width = width;
			_height = height;
		}
		
		public function endPaint(id:String):void
		{
			if(_strokes[id]){
				(_strokes[id] as PaintStroke).destroy()
				_strokes[id] = null;
			}
		}
		
		public function getStroke(id:String):BrushStroke
		{		
			return _strokes[id];
		}
	}
}