package com.cb.utils.simplepaint.brush.strokes
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.utils.Timer;

	/**
	 * Base class for all brush strokes
	 * 
	 */
	 
	public class BrushStroke extends Sprite
	{
		public static const STROKE_TIME_OUT:String = "stroke_time_out";
		protected var _color:uint;
		protected var _point:Point;
		protected var _id:String;
		private var _timer:Timer;
		
		public function BrushStroke(color:uint, start:Point, id:String)
		{
			super();
			_color = color;
			_point = start;
			_id = id;
			
			_timer = new Timer(500);
			_timer.addEventListener(TimerEvent.TIMER, onTimerComplete, false, 0, true);
			_timer.start();
		}
		
		public function get id():String
		{
			return _id;
		}
		
		protected function onTimerComplete(e:TimerEvent):void
		{
			this.dispatchEvent(new Event(STROKE_TIME_OUT, true));
		}
		
		public function paint(point:Point):void
		{
			_timer.reset();
			_timer.start();
		}
		
		public function destroy():void
		{
			_timer.removeEventListener(TimerEvent.TIMER_COMPLETE, onTimerComplete);
		}
	}
}