package com.cb.utils.simplepaint.canvas
{
	import com.cb.utils.simplepaint.brush.strokes.BrushStroke;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;

	public class PaintCanvas extends Sprite
	{
		private var _bitmapData:BitmapData;
		private var _bitmap:Bitmap;
		private var _canvas:Sprite;
		
		private var _strokes:Array;
		
		public function PaintCanvas(width:int = 400, height:int = 400)
		{
			super();
			_strokes = new Array();
			_bitmapData = new BitmapData(width, height, true, 0x00FF3300);
			
			_bitmap = new Bitmap(_bitmapData);
			this.addChild(_bitmap);
			
			_canvas = new Sprite();
			//_canvas.cacheAsBitmapMatrix = new Matrix();
			this.addChild(_canvas);
		}
		
		public function clear():void
		{
			_bitmapData.fillRect(new Rectangle(0,0,_bitmapData.width,_bitmapData.height), 0x00FF3300);
			for each(var stroke:BrushStroke in _strokes){
				_canvas.removeChild(stroke);
			}
			_strokes = new Array();
		}
		
		public function addStroke(stroke:BrushStroke):void
		{
			if(_strokes.length > 6){
				var oldStroke:BrushStroke = _strokes[0];
				_strokes = _strokes.slice(1);
				_bitmapData.draw(oldStroke);
				_canvas.removeChild(oldStroke);
			}
			_strokes.push(stroke);
			_canvas.addChild(stroke);
		}
		
		public function undo():void
		{
			if(_strokes.length > 0){
				_canvas.removeChild(_strokes.pop());
			}
		}
	}
}